#ifndef _H_107BD8DB355664EE4FA9A9739B18BAA8_Dictionary_DCPS_H_
#define _H_107BD8DB355664EE4FA9A9739B18BAA8_Dictionary_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Dictionary_.h"


namespace plotjuggler_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class Dictionary_TypeSupportInterface;

            typedef Dictionary_TypeSupportInterface * Dictionary_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Dictionary_TypeSupportInterface> Dictionary_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Dictionary_TypeSupportInterface> Dictionary_TypeSupportInterface_out;


            class Dictionary_DataWriter;

            typedef Dictionary_DataWriter * Dictionary_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Dictionary_DataWriter> Dictionary_DataWriter_var;
            typedef DDS_DCPSInterface_out < Dictionary_DataWriter> Dictionary_DataWriter_out;


            class Dictionary_DataReader;

            typedef Dictionary_DataReader * Dictionary_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Dictionary_DataReader> Dictionary_DataReader_var;
            typedef DDS_DCPSInterface_out < Dictionary_DataReader> Dictionary_DataReader_out;


            class Dictionary_DataReaderView;

            typedef Dictionary_DataReaderView * Dictionary_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Dictionary_DataReaderView> Dictionary_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Dictionary_DataReaderView> Dictionary_DataReaderView_out;

            struct Dictionary_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Dictionary_, struct Dictionary_Seq_uniq_> Dictionary_Seq;
            typedef DDS_DCPSSequence_var < Dictionary_Seq> Dictionary_Seq_var;
            typedef DDS_DCPSSequence_out < Dictionary_Seq> Dictionary_Seq_out;

            class  Dictionary_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Dictionary_TypeSupportInterface_ptr _ptr_type;
                typedef Dictionary_TypeSupportInterface_var _var_type;

                static Dictionary_TypeSupportInterface_ptr _duplicate (Dictionary_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Dictionary_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Dictionary_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Dictionary_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Dictionary_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Dictionary_TypeSupportInterface () {};
                ~Dictionary_TypeSupportInterface () {};
            private:
                Dictionary_TypeSupportInterface (const Dictionary_TypeSupportInterface &);
                Dictionary_TypeSupportInterface & operator = (const Dictionary_TypeSupportInterface &);
            };

            class  Dictionary_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Dictionary_DataWriter_ptr _ptr_type;
                typedef Dictionary_DataWriter_var _var_type;

                static Dictionary_DataWriter_ptr _duplicate (Dictionary_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Dictionary_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Dictionary_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Dictionary_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Dictionary_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Dictionary_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Dictionary_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Dictionary_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Dictionary_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Dictionary_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Dictionary_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Dictionary_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Dictionary_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Dictionary_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Dictionary_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Dictionary_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Dictionary_& instance_data) = 0;

            protected:
                Dictionary_DataWriter () {};
                ~Dictionary_DataWriter () {};
            private:
                Dictionary_DataWriter (const Dictionary_DataWriter &);
                Dictionary_DataWriter & operator = (const Dictionary_DataWriter &);
            };

            class  Dictionary_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Dictionary_DataReader_ptr _ptr_type;
                typedef Dictionary_DataReader_var _var_type;

                static Dictionary_DataReader_ptr _duplicate (Dictionary_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Dictionary_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Dictionary_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Dictionary_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Dictionary_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Dictionary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Dictionary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Dictionary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Dictionary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Dictionary_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Dictionary_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Dictionary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Dictionary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Dictionary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Dictionary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Dictionary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Dictionary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Dictionary_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Dictionary_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Dictionary_& instance) = 0;

            protected:
                Dictionary_DataReader () {};
                ~Dictionary_DataReader () {};
            private:
                Dictionary_DataReader (const Dictionary_DataReader &);
                Dictionary_DataReader & operator = (const Dictionary_DataReader &);
            };

            class  Dictionary_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Dictionary_DataReaderView_ptr _ptr_type;
                typedef Dictionary_DataReaderView_var _var_type;

                static Dictionary_DataReaderView_ptr _duplicate (Dictionary_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Dictionary_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Dictionary_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Dictionary_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Dictionary_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Dictionary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Dictionary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Dictionary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Dictionary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Dictionary_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Dictionary_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Dictionary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Dictionary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Dictionary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Dictionary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Dictionary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Dictionary_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Dictionary_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Dictionary_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Dictionary_& instance) = 0;

            protected:
                Dictionary_DataReaderView () {};
                ~Dictionary_DataReaderView () {};
            private:
                Dictionary_DataReaderView (const Dictionary_DataReaderView &);
                Dictionary_DataReaderView & operator = (const Dictionary_DataReaderView &);
            };
        }

    }

}

#endif
