#ifndef _H_D32C59303D520A6B19AAA30659305C32_DataPoints_DCPS_H_
#define _H_D32C59303D520A6B19AAA30659305C32_DataPoints_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "DataPoints_.h"


namespace plotjuggler_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class DataPoints_TypeSupportInterface;

            typedef DataPoints_TypeSupportInterface * DataPoints_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < DataPoints_TypeSupportInterface> DataPoints_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < DataPoints_TypeSupportInterface> DataPoints_TypeSupportInterface_out;


            class DataPoints_DataWriter;

            typedef DataPoints_DataWriter * DataPoints_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < DataPoints_DataWriter> DataPoints_DataWriter_var;
            typedef DDS_DCPSInterface_out < DataPoints_DataWriter> DataPoints_DataWriter_out;


            class DataPoints_DataReader;

            typedef DataPoints_DataReader * DataPoints_DataReader_ptr;
            typedef DDS_DCPSInterface_var < DataPoints_DataReader> DataPoints_DataReader_var;
            typedef DDS_DCPSInterface_out < DataPoints_DataReader> DataPoints_DataReader_out;


            class DataPoints_DataReaderView;

            typedef DataPoints_DataReaderView * DataPoints_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < DataPoints_DataReaderView> DataPoints_DataReaderView_var;
            typedef DDS_DCPSInterface_out < DataPoints_DataReaderView> DataPoints_DataReaderView_out;

            struct DataPoints_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < DataPoints_, struct DataPoints_Seq_uniq_> DataPoints_Seq;
            typedef DDS_DCPSSequence_var < DataPoints_Seq> DataPoints_Seq_var;
            typedef DDS_DCPSSequence_out < DataPoints_Seq> DataPoints_Seq_out;

            class  DataPoints_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef DataPoints_TypeSupportInterface_ptr _ptr_type;
                typedef DataPoints_TypeSupportInterface_var _var_type;

                static DataPoints_TypeSupportInterface_ptr _duplicate (DataPoints_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DataPoints_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static DataPoints_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DataPoints_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                DataPoints_TypeSupportInterface_ptr _this () { return this; }


            protected:
                DataPoints_TypeSupportInterface () {};
                ~DataPoints_TypeSupportInterface () {};
            private:
                DataPoints_TypeSupportInterface (const DataPoints_TypeSupportInterface &);
                DataPoints_TypeSupportInterface & operator = (const DataPoints_TypeSupportInterface &);
            };

            class  DataPoints_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef DataPoints_DataWriter_ptr _ptr_type;
                typedef DataPoints_DataWriter_var _var_type;

                static DataPoints_DataWriter_ptr _duplicate (DataPoints_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DataPoints_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static DataPoints_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DataPoints_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                DataPoints_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const DataPoints_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const DataPoints_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const DataPoints_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const DataPoints_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const DataPoints_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const DataPoints_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const DataPoints_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const DataPoints_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const DataPoints_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const DataPoints_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (DataPoints_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DataPoints_& instance_data) = 0;

            protected:
                DataPoints_DataWriter () {};
                ~DataPoints_DataWriter () {};
            private:
                DataPoints_DataWriter (const DataPoints_DataWriter &);
                DataPoints_DataWriter & operator = (const DataPoints_DataWriter &);
            };

            class  DataPoints_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef DataPoints_DataReader_ptr _ptr_type;
                typedef DataPoints_DataReader_var _var_type;

                static DataPoints_DataReader_ptr _duplicate (DataPoints_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DataPoints_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static DataPoints_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DataPoints_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                DataPoints_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (DataPoints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DataPoints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DataPoints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DataPoints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DataPoints_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DataPoints_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DataPoints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DataPoints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DataPoints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DataPoints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DataPoints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DataPoints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DataPoints_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DataPoints_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DataPoints_& instance) = 0;

            protected:
                DataPoints_DataReader () {};
                ~DataPoints_DataReader () {};
            private:
                DataPoints_DataReader (const DataPoints_DataReader &);
                DataPoints_DataReader & operator = (const DataPoints_DataReader &);
            };

            class  DataPoints_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef DataPoints_DataReaderView_ptr _ptr_type;
                typedef DataPoints_DataReaderView_var _var_type;

                static DataPoints_DataReaderView_ptr _duplicate (DataPoints_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DataPoints_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static DataPoints_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DataPoints_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                DataPoints_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (DataPoints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DataPoints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DataPoints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DataPoints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DataPoints_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DataPoints_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DataPoints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DataPoints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DataPoints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DataPoints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DataPoints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DataPoints_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DataPoints_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DataPoints_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DataPoints_& instance) = 0;

            protected:
                DataPoints_DataReaderView () {};
                ~DataPoints_DataReaderView () {};
            private:
                DataPoints_DataReaderView (const DataPoints_DataReaderView &);
                DataPoints_DataReaderView & operator = (const DataPoints_DataReaderView &);
            };
        }

    }

}

#endif
